/*
 * Copyright 2009 Prime Technology.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.primefaces.component.column;

import javax.faces.webapp.UIComponentELTag;
import javax.faces.component.UIComponent;

public class ColumnTag extends UIComponentELTag {

	private javax.el.ValueExpression _sortBy;
	private javax.el.ValueExpression _resizable;
	private javax.el.ValueExpression _filter;
	private javax.el.ValueExpression _selectionMode;
	private javax.el.ValueExpression _parser;
	private javax.el.ValueExpression _width;

	public void release(){
		super.release();
		this._sortBy = null;
		this._resizable = null;
		this._filter = null;
		this._selectionMode = null;
		this._parser = null;
		this._width = null;
	}

	protected void setProperties(UIComponent comp){
		super.setProperties(comp);

		org.primefaces.component.column.Column component = null;
		try {
			component = (org.primefaces.component.column.Column) comp;
		} catch(ClassCastException cce) {
			throw new IllegalStateException("Component " + component.toString() + " not expected type.");
		}

		if(_sortBy != null) {
			component.setValueExpression("sortBy", _sortBy);
		}
		if(_resizable != null) {
			component.setValueExpression("resizable", _resizable);
		}
		if(_filter != null) {
			component.setValueExpression("filter", _filter);
		}
		if(_selectionMode != null) {
			component.setValueExpression("selectionMode", _selectionMode);
		}
		if(_parser != null) {
			component.setValueExpression("parser", _parser);
		}
		if(_width != null) {
			component.setValueExpression("width", _width);
		}
	}

	public String getComponentType() {
		return Column.COMPONENT_TYPE;
	}

	public String getRendererType() {
		return null;
	}

	public void setSortBy(javax.el.ValueExpression expression){
		this._sortBy = expression;
	}

	public void setResizable(javax.el.ValueExpression expression){
		this._resizable = expression;
	}

	public void setFilter(javax.el.ValueExpression expression){
		this._filter = expression;
	}

	public void setSelectionMode(javax.el.ValueExpression expression){
		this._selectionMode = expression;
	}

	public void setParser(javax.el.ValueExpression expression){
		this._parser = expression;
	}

	public void setWidth(javax.el.ValueExpression expression){
		this._width = expression;
	}

}